// -*- c++ -*-
// Generated by assa-genesis
//------------------------------------------------------------------------------
// $Id: LogMon.cpp,v 1.3 2005/03/14 03:45:45 vlg Exp $
//------------------------------------------------------------------------------
//                            LogMon.cpp
//------------------------------------------------------------------------------
//  Copyright (c) 2003 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Thu Apr 17 22:49:49 2003
//
//------------------------------------------------------------------------------

#include <assa/INETAddress.h>
#include <assa/TimeVal.h>

#include "LogMon-main.h"
#include "LogMon.h"

// Static declarations mandated by Singleton class
ASSA_DECL_SINGLETON(LogMon);

LogMon::
LogMon () : 
	m_exit_value (0),
	m_peer (NULL)
{
    // ---Configuration---
    rm_opt ('f', "config-file"  );
    rm_opt ('n', "instance"     );

    // ---Process bookkeeping---
    rm_opt ('b', "daemon"       );
    rm_opt ('l', "pidfile"      );
	rm_opt ('L', "ommit-pidfile");
    m_ommit_pidflock_flag = true;

    /*---
     * By defauil disable all debugging
     *---*/
    m_debug_mask = ASSA::APP | ASSA::ERROR;
    m_log_file = "LogMon.log";
	
	setPortName ("assalmon");	// ASSA logging server monitoring port
}

void
LogMon::
initServer ()
{
    trace("LogMon::initServer");

	m_peer = new LogConn;
	ASSA::INETAddress lmon_addr (getPortName ().c_str ());

	ASSA::TimeVal timeout (5.0); 
	m_connector.open (timeout, ASSA::async, REACTOR);

	if (m_connector.connect (m_peer, lmon_addr) < 0) {
		DL((ASSA::ERROR,"Failed to connect to server\n"));
		setStopServerFlag ();
		return;
	}
	
    DL((ASSA::APP,"Service has been initialized\n"));
}

void
LogMon::
processServer ()
{
    trace("LogMon::processServer");

    while (!stopServer()) {
        m_reactor.waitForEvents ();
    }

    // Shut the service down
    m_reactor.stopReactor ();
    DL((ASSA::APP,"Service stopped!\n"));
}


